%define emacsbin emacs
# define emacsbin emacs-nox
%define ModeName auctex
%define emacs_version %(%emacsbin --version | head --lines=1 | cut -d' ' --fields=3 | cut -d. --fields=1,2)
%if "%emacs_version" == ""
# Not to leave the macro undefined in case of no emacs.
%define emacs_version 0
%endif
%define _aucstatedir %_localstatedir/emacs/site-lisp/%ModeName

Name: emacs-mode-%ModeName
Version: 11.14
Release: alt7

Summary: Enhanced LaTeX mode for GNU Emacs
License: GPL
Group: Editors
Url: http://www.cs.auc.dk/~amanda/%ModeName/
BuildArch: noarch

#Source0: ftp://sunsite.auc.dk/packages/auctex/%ModeName-%version.tar.bz2
Source0: ftp://ftp.dina.kvl.dk/pub/Staff/Per.Abrahamsen/auctex/%ModeName-%version.tar.bz2
%if "%_without_source" == "--without-source"
NoSource: 0
%endif

Source10: %name-11.10-info.ALT

Patch0: %ModeName-10.0g-fixinfo.patch
Patch1: %name-11.10-fixpath.patch
Patch2: %name-11.10-make-more.patch
Patch3: %ModeName-10.0g-printerlist.patch
Patch4: %ModeName-9.9p-customize.patch
Patch5: %ModeName-11-face.patch

# Due to patches 1 and 3, the administrator of a system won't have to set
# any site-specific variables for AUC TeX.

Obsoletes: auctex

Requires: common-licenses
Requires: emacs >= %emacs_version

# The list is quite strange -- but it looks like it really doesn't want to compile without any of these.
BuildPreReq: cups-common libcups libssl tetex tetex-latex XFree86

# Automatically added by buildreq on Wed Feb 20 2002
#BuildRequires: Eterm XFree86 XFree86-libs Xaw3d cups-common elib emacs-common emacs-el emacs-leim emacs-mode-auctex gtk-themes ispell ispell-en ispell-ru ispell-ua lclint libcups libjpeg libssl libtiff libungif maxima ocaml octave rpm-utils tetex tetex-latex words xpm

%define require_compiler %(rpm -qf "$(which %emacsbin)" --queryformat=%%{NAME} 2> /dev/null)
%if "%require_compiler" != ""
BuildRequires: %require_compiler
%(echo '%require_compiler provides the used Emacs Lisp compiler (%emacsbin)' 1>&2)
%else
BuildRequires: emacs
%(echo 'emacs provides the used Emacs Lisp compiler (%emacsbin)' 1>&2)
%endif

# We need el-pkgutils to genreate file-lists:
BuildPreReq: emacs-common >= 21.1-alt11

%description
AUC TeX is a comprehensive, customizable, integrated environment for
writing, editing and processing input files for LaTeX using GNU Emacs.

(Emacs Lisp code is principally byte-compiled, install %name-el for sources.)

%description -l ru_RU.CP1251
AUC TeX  ,     ,
    LaTeX   Emacs.

   Emacs Lisp ,    
  %name-el

%package el
Summary: The Emacs Lisp sources for bytecode included in %name
Group: Development/Other

Requires: %name = %version-%release

%description el
%name-el contains the Emacs Lisp sources for the bytecode included in the %name package,
that extends the Emacs editor.

You need to install %name-el only if you intend to modify any of the
%name code or see some Lisp examples.

%description el -l ru_RU.CP1251
 %name-el      %name,  
   Emacs.

%name-el   ,       
%name,     .

%prep
%setup -q -n %ModeName-%version
%patch -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
%make_build EMACS=%emacsbin
%make_build contrib EMACS=%emacsbin

# Build docs
pushd doc
%make_build all {INSTALLATION,CHANGES,README}
popd

%install
%__install -d $RPM_BUILD_ROOT{%_emacslispdir,%_infodir}

%define _makeinstall_target install install-contrib install-info
%makeinstall lispdir=$RPM_BUILD_ROOT%_emacslispdir
# Fix wrong constant pointing to the path:
%__subst  "s|$RPM_BUILD_ROOT||" $RPM_BUILD_ROOT/%_emacslispdir/tex-site.el

%__install -d $RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d

{ 
    echo "(GNUEmacs"
    echo "  (require 'tex-site)"
    echo ";  (setq-default TeX-master nil)"
    echo ";  (setq TeX-parse-self t)"
    echo ";  (setq TeX-auto-save t)"
    echo ";  (setq TeX-default-mode 'latex-mode)"

    echo ') ; close GNUEmacs macro block'
} > $RPM_BUILD_ROOT%_sysconfdir/emacs/site-start.d/%ModeName.el



# relocate the directory for storing generated data to the new place
%__install -d $RPM_BUILD_ROOT%_aucstatedir
%__mv $RPM_BUILD_ROOT/%_emacslispdir/auctex/auto $RPM_BUILD_ROOT%_aucstatedir

# install ALT's info:
%__install -m0644 %SOURCE10 ALT-packaging-info

# The license:
%__ln_s -f %_licensedir/GPL-2 COPYING

#
# create file lists
%__rm -f main.ls el.ls dirs.ls

. %_libdir/emacs/el-pkgutils.sh
EMACS_BIN=%emacsbin

fraction \
 '(dirs "%_emacslispdir/%ModeName" "%%dir") "dirs.ls"' \
 '(elc "%_emacslispdir/%ModeName") "main.ls"' \
 '(el-with-elc "%_emacslispdir/%ModeName") "el.ls"' \
 '(el-without-elc "%_emacslispdir/%ModeName"
    (lambda(f) (if (string-match "hilit-LaTeX" f) "#") )) "main.ls"' \
 '(etc "%_emacslispdir/%ModeName") "main.ls"' # .nosearch are significant

#find $RPM_BUILD_ROOT%_emacslispdir/%ModeName \
#  -type f -print | sed "s^$RPM_BUILD_ROOT^^" \
#  | fgrep -v -f el-filelist \
#  > non-el-filelist

cat dirs.ls \
    | tee --append main.ls el.ls &> /dev/null \
    && %__rm -f dirs.ls

%post
%install_info %ModeName

%preun
%uninstall_info %ModeName

%files -f main.ls
%doc --no-dereference COPYING
%doc PROBLEMS ChangeLog
%doc doc/{INSTALLATION,CHANGES,README}
%doc doc/*.dvi
%doc ALT-packaging-info
%_infodir/*
%config(noreplace) %_sysconfdir/emacs/site-start.d/%{ModeName}.el
%attr(1777,root,root) %dir %_aucstatedir
%attr(1777,root,root) %dir %_aucstatedir/auto
%_aucstatedir
%_emacslispdir/tex-site.el 

%files el -f el.ls
%doc --no-dereference COPYING

%changelog
* Sun May  9 2004 Ivan Zakharyaschev <imz@altlinux.ru> 11.14-alt7
- Fix hard-coded path constant in tex-site.el (spoilt by build env);
- include .nosearch files.

* Mon Feb 17 2003 Ott Alex <ott@altlinux.ru> 11.14-alt6
- Fixing spec file

* Sat Jan 11 2003 Ott Alex <ott@altlinux.ru> 11.14-alt5
- New version of package
- fixing problems with wrong number of arguments in font-latex-setup function

* Thu Sep 19 2002 Ott Alex <ott@altlinux.ru> 11.11-alt4
- put tex-site.el on standart place. Call it from /etc/emacs/site-start.d/auctex.el

* Tue Apr 16 2002 Ivan Zakharyaschev <imz@altlinux.ru> 11.11-alt3
- package:
  + more accurate description;
  + more accurate group for el subpkg (resolves \#836 at bugs.altlinux.ru);
- files:
  + do not include hilit-LaTeX.el (useful for old Emacs 19 only);

* Mon Apr  8 2002 Ivan Zakharyaschev <imz@altlinux.ru> 11.11-alt2
- require the current Emacs version or later;

* Thu Feb 28 2002 Ivan Zakharyaschev <imz@altlinux.ru> 11.11-alt1
- new mainstream version (11.11);
- spec-file: use el-pkgutils for generating filelists;
- %name-el requires %name (strict %%release deps);

* Thu Feb 28 2002 Ivan Zakharyaschev <imz@altlinux.ru> 11.10-alt4
- Run the start-script only for GNUEmacs (XEmacs has its own AUCTeX).

* Wed Feb 20 2002 Dmitry V. Levin <ldv@alt-linux.org> 11.10-alt3
- Updated buildrequires.
- Updated nosource logic.

* Sat Dec  8 2001 Ivan Zakharyaschev <imz@altlinux.ru> 11.10-alt2
- fix the name of the /etc/emacs/site-start.d/ entry.

* Sat Dec  8 2001 Ivan Zakharyaschev <imz@altlinux.ru> 11.10-alt1
- new mainstream version (11.10)
- renamed: auctex -> emacs-mode-auctex
- splitted into main package (bytecode) and a package with the sources
- "hand-generated" style descriptions should work: the path for them fixed
  (it was wrongly patched in previous pkg releases)
- linked the license from common-licenses (GPL-2)
- auto/ excluded from %_emacslispdir/%ModeName/ for it empty and not used
- for packagers:
  + using global def %%_emacslispdir

* Wed Jul 25 2001 Ivan Zakharyaschev <imz@altlinux.ru> 10.0g-alt2
- update info about special customization in the pkg
- change the printerlist patch for better handling error msgs

* Wed Jul 25 2001 Ivan Zakharyaschev <imz@altlinux.ru> 10.0g-alt1
- new version (10.0g).

* Wed Jul 25 2001 Ivan Zakharyaschev <imz@altlinux.ru> 9.9p-alt4
- The default value for TeX-master changed: now it makes AUC TeX
  ask you about the master file if the file doesn't seem to be a master
  (i.e. doesn't contain \docuemtnclass).

* Sat Jul 21 2001 Ivan Zakharyaschev <imz@altlinux.ru> 9.9p-alt3
- put generated data to %_aucstatedir

* Sat Jul 21 2001 Ivan Zakharyaschev <imz@altlinux.ru> 9.9p-alt2
- add patches for setting variables with site-specific values
- tried to make more modules (hilit and japanese) -- hilit didn't
  compile.
- add more documentation (plain text and DVIs)

* Thu Jul 19 2001 Ivan Zakharyaschev <imz@altlinux.ru> 9.9p-alt1
- first ALT build

* Sat Apr 14 2001 Francis Galiegue <fg@mandrakesoft.com> 9.9p-5mdk

- BuildRequires emacs-X11 and not only emacs

* Wed Dec 13 2000 Pixel <pixel@mandrakesoft.com> 9.9p-4mdk
- requires the emacs version used for building
(don't need to have a xemacs version, xemacs bundles it)

* Mon Nov 27 2000 Pixel <pixel@mandrakesoft.com> 9.9p-3mdk
- add build_req

* Sat Sep  2 2000 Pixel <pixel@mandrakesoft.com> 9.9p-2mdk
- mandrake adaptation
- cleanup

* Fri Jul 10 1998 W.L. Estes <wlestes@wlestes.uncg.edu>
- build root now used
- cleaned up file list
- fixed url tag
- added CHANGES and ChangeLog to doc files
- now requires emacs >= 20
- added \%clean
- misc spec file cosmetic cleanups

 *Wed Mar 11 1998 Martin Schimschak <masch@theo-phys.uni-essen.de>
 - initial revision for auctex 9.8l
# Local Variables:
# compile-command: "rpmbuild -ba --target=i586 auctex.spec"
# End:
